# php Module

## Overview

This module install and configure php server.

## Usage

Default configuration:

```puppet
include php
```

Custom configuration:

```puppet
class { 'php':
    php                               => true,
    php_fpm                           => true,
    engine                            => 'On',
    short_open_tag                    => 'Off',
    asp_tags                          => 'Off',
    precision                         => '14',
    output_buffering                  => '4096',
    zlib_output_compression           => 'Off',
    implicit_flush                    => 'Off',
    unserialize_callback_func         => '',
    serialize_precision               => '17',
    open_basedir                      => '"/var/www/"',
    disable_functions                 => '',
    disable_classes                   => '',
    zend_enable_gc                    => 'On',
    expose_php                        => 'Off',
    max_execution_time                => '30',
    max_input_time                    => '60',
    memory_limit                      => '128M',
    error_reporting                   => 'E_ALL & ~E_DEPRECATED & ~E_STRICT',
    display_errors                    => 'Off',
    display_startup_errors            => 'Off',
    log_errors                        => 'On',
    log_errors_max_len                => '1024',
    ignore_repeated_errors            => 'Off',
    ignore_repeated_source            => 'Off',
    report_memleaks                   => 'On',
    track_errors                      => 'Off',
    html_errors                       => 'On',
    error_log                         => '/var/log/php_error.log',
    variables_order                   => '"GPCS"',
    request_order                     => '"GP"',
    register_argc_argv                => 'Off',
    auto_globals_jit                  => 'On',
    post_max_size                     => '8M',
    auto_prepend_file                 => '',
    auto_append_file                  => '',
    default_mimetype                  => '"text/html"',
    default_charset                   => '"UTF-8"',
    doc_root                          => '',
    user_dir                          => '',
    enable_dl                         => 'Off',
    file_uploads                      => 'On',
    upload_tmp_dir                    => '/tmp',
    upload_max_filesize               => '2M',
    max_file_uploads                  => '20',
    allow_url_fopen                   => 'On',
    allow_url_include                 => 'Off',
    default_socket_timeout            => '60',
    cli_server_color                  => 'On',
    pdo_mysql_cache_size              => '2000',
    pdo_mysql_default_socket          => '',
    sendmail_path                     => '/usr/sbin/sendmail -t -i',
    mail_add_x_header                 => 'On',
    sql_safe_mode                     => 'Off',
    odbc_allow_persistent             => 'On',
    odbc_check_persistent             => 'On',
    odbc_max_persistent               => '-1',
    odbc_max_links                    => '-1',
    odbc_defaultlrl                   => '4096',
    odbc_defaultbinmode               => '1',
    ibase_allow_persistent            => '1',
    ibase_max_persistent              => '-1',
    ibase_max_links                   => '-1',
    ibase_timestampformat             => '"%Y-%m-%d %H:%M:%S"',
    ibase_dateformat                  => '"%Y-%m-%d"',
    ibase_timeformat                  => '"%H:%M:%S"',
    mysql_allow_local_infile          => 'On',
    mysql_allow_persistent            => 'On',
    mysql_cache_size                  => '2000',
    mysql_max_persistent              => '-1',
    mysql_max_links                   => '-1',
    mysql_default_port                => '',
    mysql_default_socket              => '',
    mysql_default_host                => '',
    mysql_default_user                => '',
    mysql_default_password            => '',
    mysql_connect_timeout             => '60',
    mysql_trace_mode                  => 'Off',
    mysqli_max_persistent             => '-1',
    mysqli_allow_persistent           => 'On',
    mysqli_max_links                  => '-1',
    mysqli_cache_size                 => '2000',
    mysqli_default_port               => '3306',
    mysqli_default_socket             => '',
    mysqli_default_host               => '',
    mysqli_default_user               => '',
    mysqli_default_pw                 => '',
    mysqli_reconnect                  => 'Off',
    mysqlnd_collect_statistics        => 'On',
    mysqlnd_collect_memory_statistics => 'Off',
    pgsql_allow_persistent            => 'On',
    pgsql_auto_reset_persistent       => 'Off',
    pgsql_max_persistent              => '-1',
    pgsql_max_links                   => '-1',
    pgsql_ignore_notice               => '0',
    pgsql_log_notice                  => '0',
    sybct_allow_persistent            => 'On',
    sybct_max_persistent              => '-1',
    sybct_max_links                   => '-1',
    sybct_min_server_severity         => '10',
    sybct_min_client_severity         => '10',
    bcmath_scale                      => '0',
    session_save_handler              => 'files',
    session_use_strict_mode           => '0',
    session_use_cookies               => '1',
    session_use_only_cookies          => '1',
    session_name                      => 'PHPSESSID',
    session_auto_start                => '0',
    session_cookie_lifetime           => '0',
    session_cookie_path               => '/',
    session_cookie_domain             => '',
    session_cookie_httponly           => '',
    session_serialize_handler         => 'php',
    session_gc_probability            => '1',
    session_gc_divisor                => '1000',
    session_gc_maxlifetime            => '1440',
    session_referer_check             => '',
    session_cache_limiter             => 'nocache',
    session_cache_expire              => '180',
    session_use_trans_sid             => '0',
    session_hash_function             => '0',
    session_hash_bits_per_character   => '5',
    url_rewriter_tags                 => '"a=href,area=href,frame=src,input=src,form=fakeentry"',
    mssql_allow_persistent            => 'On',
    mssql_max_persistent              => '-1',
    mssql_max_links                   => '-1',
    mssql_min_error_severity          => '10',
    mssql_min_message_severity        => '10',
    mssql_compatibility_mode          => 'Off',
    mssql_secure_connection           => 'Off',
    tidy_clean_output                 => 'Off',
    soap_wsdl_cache_enabled           => '1',
    soap_wsdl_cache_dir               => '"/tmp"',
    soap_wsdl_cache_ttl               => '86400',
    soap_wsdl_cache_limit             => '5',
    ldap_max_links                    => '-1',
 }
```

php-fpm configuration:

```puppet
class { 'php::php_fpm':
    user  => 'www-data',
    group => 'www-data',
}
```
